local TSM = select(2, ...)
local Sort = TSM:NewModule("Sort")
local Util = TSM:GetModule("Util")
TSM.Data = {}
TSMAPI.GBankData = {}
local NUMBER_OF_GBANK_SLOTS = 98

function TSM:GUILDBANKFRAME_OPENED()
	if (BagnonFrameguildbank and BagnonFrameguildbank:IsShown()) then  -- Bagnon Handling
		--print("Bagnon detected")
		self.SortToGBankButton = CreateFrame("Button","SortToGBank",BagnonFrameguildbank,"GameMenuButtonTemplate")
		self.SortToGBankButton:SetPoint("BOTTOMRIGHT", -190, 5)
		self.SortToGBankButton:SetWidth(110)
		self.SortToGBankButton:SetText("Sort To Guild")
		self.SortToGBankButton:SetScript("OnClick", function()
			self.SortToGBankButton:Disable()
			Sort:StartGbankPut()
		end
		)
		
		self.SortGBankButton = CreateFrame("Button","SortGBank", BagnonFrameguildbank,"GameMenuButtonTemplate")
		self.SortGBankButton:SetPoint("BOTTOMRIGHT", -300, 5)
		self.SortGBankButton:SetWidth(110)
		self.SortGBankButton:SetText("Sort Guild")
		self.SortGBankButton:SetScript("OnClick", function()
			self.SortGBankButton:Disable()
			Sort:StartGbankSort()
		end
		)
	else
		--print("Default GBank")
		self.SortToGBankButton = CreateFrame("Button","SortToGBank", GuildBankFrame,"GameMenuButtonTemplate")
		self.SortToGBankButton:SetPoint("BOTTOMRIGHT", -510, 30)
		self.SortToGBankButton:SetWidth(110)
		self.SortToGBankButton:SetText("Sort To Guild")
		self.SortToGBankButton:SetScript("OnClick", function()
			self.SortToGBankButton:Disable()
			Sort:StartGbankPut()
		end
		)
		
		self.SortGBankButton = CreateFrame("Button","SortGBank", GuildBankFrame,"GameMenuButtonTemplate")
		self.SortGBankButton:SetPoint("BOTTOMRIGHT", -630, 30)
		self.SortGBankButton:SetWidth(110)
		self.SortGBankButton:SetText("Sort Guild")
		self.SortGBankButton:SetScript("OnClick", function()
			self.SortGBankButton:Disable()
			Sort:StartGbankSort()
		end
		)
	end
end

function Sort:StartGbankSort()
	if(GuildBankFrame and GuildBankFrame:IsShown()) then
		TSM:Print("Starting to sort items")
		Sort:GenerateGbankItems()
		local TableSize = #TSMAPI.GBankData
		TSM:Print(format("%d moves to make.",TableSize))
		TSM.PassItemPlacement = false
		TSMAPI:CreateTimeDelay("GBankSort", 1,Sort.GbankSortRun, 2.5)
	else
		TSM:Print("Not at guild bank")
	end
end

TSM.IterationNumberGbankSort = 1
TSM.PassItemPlacement = false
function Sort.GbankSortRun()
	if TSM.PassItemPlacement == true then return end
	--print("Passed")
	
	local TableSize = #TSMAPI.GBankData
	--print(TableSize)
	
	Sort.FreeBag, Sort.FreeSlot = Util:GetFreeBagSpace()

	if TSM.IterationNumberGbankSort <= TableSize then
		TSM.PassItemPlacement = true
		Sort.Tab = TSMAPI.GBankData[TSM.IterationNumberGbankSort]["TabToMoveTo"]
		local CurrentTab = TSMAPI.GBankData[TSM.IterationNumberGbankSort]["CurrentTab"]
		local Slot = TSMAPI.GBankData[TSM.IterationNumberGbankSort]["Slot"]
		--local Item = TSMAPI.GBankData[GenerateGbankItemsIterationNumber]["Item"]
		
		if Sort.Tab == nil or CurrentTab == nil then
			TSM.PassItemPlacement = false
			TSM.IterationNumberGbankSort = TSM.IterationNumberGbankSort + 1
			return
		end
		
		SetCurrentGuildBankTab(CurrentTab)
		PickupGuildBankItem(CurrentTab,Slot)
		--print("Picked up item")
		PickupContainerItem(Sort.FreeBag, Sort.FreeSlot)
		
		
		TSMAPI:CreateTimeDelay("GBankSort2", 1, Sort.PlaceItem)
	else
		TSM.PassItemPlacement = false
		TSMAPI.GBankData = {}
		TSM.IterationNumberGbankSort = 1
		TSM:Print("Finished sorting items.")
		TSM.SortGBankButton:Enable()
		TSMAPI:CancelFrame("GBankSort")
	end
end

function Sort.PlaceItem()
	SetCurrentGuildBankTab(Sort.Tab)
	UseContainerItem(Sort.FreeBag, Sort.FreeSlot)
	--print("Placed item into gbank")
	TSM.IterationNumberGbankSort = TSM.IterationNumberGbankSort + 1
	TSM.PassItemPlacement = false
end



function Sort:StartGbankPut()
	if(GuildBankFrame and GuildBankFrame:IsShown()) then
		TSM:Print("Starting to move items")
		Sort:GenerateBagItems()
		TSMAPI:CreateTimeDelay("GBankPut", 0.5,Sort.GbankPutRun, 0.60)
	else
		TSM:Print("Not at guild bank")
	end
end

local IterationNumberGbankPut = 1
local GbankPutReRun = true
function Sort.GbankPutRun()
	--print("Running")
	
	local TableSize = #TSM.Data
	--print(TableSize)
	if IterationNumberGbankPut <= TableSize then		
		local Tab = TSM.Data[IterationNumberGbankPut]["Tab"]
		local BagSlotNum = TSM.Data[IterationNumberGbankPut]["BagSlotNum"]
		local Bag = TSM.Data[IterationNumberGbankPut]["Bag"]
		
		--print("Tab = "..tostring(Tab).." Slot Num = "..tostring(BagSlotNum).." Bag = "..tostring(Bag))
		if Tab == nil or Bag == nil or BagSlotNum == nil then
			IterationNumberGbankPut = IterationNumberGbankPut + 1
			return
		end
		
		if GetCurrentGuildBankTab ~= Tab then
			SetCurrentGuildBankTab(Tab)
		end
		UseContainerItem(Bag, BagSlotNum)
		
		IterationNumberGbankPut = IterationNumberGbankPut + 1
	elseif GbankPutReRun == true then
		--print("Re-running")
		Sort:GenerateBagItems()
		GbankPutReRun = false
	else
		--print("Iteration entered cancel")
		GbankPutReRun = true
		IterationNumberGbankPut = 1
		TSM:Print("Finished moving items.")
		TSM.SortToGBankButton:Enable()
		TSMAPI:CancelFrame("GBankPut")
	end
end


function Sort:GenerateGbankItems()
	TSMAPI.GBankData = {}
	local	GenerateGbankItemsIterationNumber = 0
	local NumTabs = GetNumGuildBankTabs()
	local	Guild
	local	Tab
	local	Item
	
	if TSM.PlayerGuild == nil then
		TSM.PlayerGuild = select(1,GetGuildInfo("player"))
	end
	
	for CurrentTab = 1, NumTabs, 1 do
		for Slot = 1, NUMBER_OF_GBANK_SLOTS, 1 do
			Item = GetGuildBankItemLink(CurrentTab, Slot)
			Guild, Tab = Util:CheckTabAndGuild(Item)
			
			if Guild == nil or Tab == nil then
			
			elseif CurrentTab == Tab then
				--TSM:Print("Correct Tab")
			else
				if Guild == TSM.PlayerGuild then
					GenerateGbankItemsIterationNumber = GenerateGbankItemsIterationNumber + 1
					TSMAPI.GBankData[GenerateGbankItemsIterationNumber] = {}
					TSMAPI.GBankData[GenerateGbankItemsIterationNumber]["TabToMoveTo"] = Tab
					TSMAPI.GBankData[GenerateGbankItemsIterationNumber]["CurrentTab"] = CurrentTab
					TSMAPI.GBankData[GenerateGbankItemsIterationNumber]["Slot"] = Slot
					--TSMAPI.GBankData[GenerateGbankItemsIterationNumber]["Item"] = Item
					TSMAPI.GBankData[GenerateGbankItemsIterationNumber]["CurrentBagSlot"] = 0
					TSMAPI.GBankData[GenerateGbankItemsIterationNumber]["CurrentBag"] = 0
				else
					print("Guild not equal to Guild")
				end
			end
		end
	end

end


function Sort:GenerateBagItems()
	TSM.Data = {}
	local	Bags = 0
	local	Guild
	local	Tab
	local	Item
	local	GenerateBagItemsIterationNumber = 0
	
	if TSM.PlayerGuild == nil then
		TSM.PlayerGuild = select(1,GetGuildInfo("player"))
	end
	
	for BagSlot = 0, 4, 1 do
		if GetContainerNumSlots(BagSlot) then
			Bags = Bags + 1
		end
	end
	
	for Bag = 1, Bags, 1 do
		local BagSlotNumbers = GetContainerNumSlots(Bag)
		
		for BagSlotNum = 1, BagSlotNumbers, 1 do
			Item = GetContainerItemID(Bag, BagSlotNum)
			Guild, Tab = Util:CheckTabAndGuild(Item)
			--print(Guild, Tab)
			if Guild == nil or Tab == nil then
				--TSM:Print("Not working")
			else
				if Guild == TSM.PlayerGuild then
					GenerateBagItemsIterationNumber = GenerateBagItemsIterationNumber + 1
					TSM.Data[GenerateBagItemsIterationNumber] = {}
					TSM.Data[GenerateBagItemsIterationNumber]["Tab"] = Tab
					--TSM.Data[GenerateBagItemsIterationNumber]["Item"] = Item
					TSM.Data[GenerateBagItemsIterationNumber]["BagSlotNum"] = BagSlotNum
					TSM.Data[GenerateBagItemsIterationNumber]["Bag"] = Bag
				else
					print("Guild not equal to Guild")
				end
			end
		end
	end
end